with Interfaces; use Interfaces;

package body Shardware is

  function TempBytes (Instruction : ByteArr) return ByteArr is 
    TheBytes : ByteArr (1 .. 4);
  begin
    TheBytes (1) := Instruction (7);
    TheBytes (2) := Instruction (8);
    TheBytes (3) := Instruction (9);
    TheBytes (4) := Instruction (10);    
    return TheBytes;
  end TempBytes;

  function UnToSignedInt (Value : Unsigned_32) return Integer is 
    Diff1 : Integer := 0;
    Diff2 : Integer := 0;
  begin
    if Value > 2147483647 then
      Diff1 := Integer(Value - 2147483648);
      Diff2 := Diff1 - 2147483647;
      return Diff2 - 1;
    else
      return Integer(Value);
    end if;
  end UnToSignedInt;

  function BytesToBits (TheBytes : ByteArr) return BitArr is 
    CurByte : Byte := 0; 
    Buff : BitArr (1 .. 32);
    Counter : Integer := 0;
  begin
    for i in 1 .. 32 loop 
      Buff (i) := False;
    end loop;
  for i in 1 .. 4 loop
      CurByte := TheBytes (i);
      for j in reverse 1 .. 8 loop
        if CurByte mod 2 > 0 then
          Buff (j + Counter) := True;
        else
          Buff (j + Counter) := False;
        end if;
        CurByte := CurByte / 2;
      end loop;
      Counter := Counter + 8;
    end loop;
    return Buff;
  end BytesToBits;

  function BitsToBytes (BinNumber : BitArr) return ByteArr is
    ReverseBin : BitArr (1 .. 32);
    I : Integer := 1;
    CurByte : Byte := 0;
    Buff : ByteArr (1 .. 4);
    Counter : Integer := 24;
  begin
    for k in reverse 1 .. 32 loop
      ReverseBin (I) := BinNumber (k); -- TODO: Unbloat this mess somehow?
      I := I + 1;
    end loop;
    for i in 1 .. 4 loop
      CurByte := 0;
      for j in reverse 1 .. 8 loop
        if ReverseBin (j + Counter) then 
          CurByte := CurByte + (2 ** (j - 1));
        end if;
      end loop;
      Counter := Counter - 8;
      Buff (i) := CurByte;
    end loop;
    return Buff;
  end BitsToBytes;

  function MyShiftU (Value : Byte; Amount : Integer) return Unsigned_32 is 
  begin
    return Unsigned_32(Shift_Left(Unsigned_128(Value), Amount));
  end MyShiftU;

  function BytesToI (TheBytes : ByteArr) return Integer is
  begin
    return UnToSignedInt(BytesToU(TheBytes));
  end BytesToI;

  function BytesToF (TheBytes : ByteArr) return Float is 
    Result : Float := 0.0;
    TheBits : BitArr (1 .. 32);
    BitBuff : BitArr (1 .. 32);
    Mantissa : Float := 0.0;
  begin
    TheBits := BytesToBits(TheBytes);

    --BitsToBytes(BitBuff);

    return Result;
  end BytesToF;

  function BytesToU (TheBytes : ByteArr) return Unsigned_32 is
  begin
    return Unsigned_32(MyShiftU(TheBytes (1), 24) 
    + MyShiftU(TheBytes (2), 16)
    + MyShiftU(TheBytes (3), 8) 
    + Unsigned_32(TheBytes (4)));
  end BytesToU;

  procedure MovI (Register : in out Integer; Value : Integer) is
  begin
    Register := Value;
  end MovI;

  procedure AddI (Register : in out Integer; Value : Integer) is
  begin
    Register := Register + Value;
  end AddI;

  procedure MovF (Register : in out Float; Value : Float) is 
  begin
    Register := Value;
  end MovF;

  procedure AddF (Register : in out Float; Value : Float) is 
  begin
    Register := Register + Value;
  end AddF;

  procedure MovU (Register : in out Unsigned_32; Value : Unsigned_32) is 
  begin
    Register := Value;
  end MovU;

  procedure AddU (Register : in out Unsigned_32; Value : Unsigned_32) is 
  begin
    Register := Register + Value;
  end AddU;


end Shardware;
